/**
 * Parse configuration files. A copy of the
 * config parser in Python.
 * @author: Joseph Jennings
 * @version: 2017.08.06
 */

#pragma once

#include <string>
#include <map>
#include <vector>

class ConfigParser {
public:
  ConfigParser(){};
  ConfigParser(int argc, char **argv);
  ConfigParser(int argc, char **argv, bool initsep);
  int get_int(const std::string &sec, const std::string &key);
  int get_int(const std::string &sec, const std::string &key, const int &def);
  std::vector<int> get_ints(const std::string &sec, const std::string &key);
  bool get_bool(const std::string &sec, const std::string &key);
  bool get_bool(const std::string &sec, const std::string &key, const bool &def);
  float get_float(const std::string &sec, const std::string &key);
  float get_float(const std::string &sec, const std::string &key, const float &def);
  std::vector<float> get_floats(const std::string &sec, const std::string &key);
  double get_double(const std::string &sec, const std::string &key);
  std::vector<double> get_doubles(const std::string &sec, const std::string &key);
  std::string get(const std::string &sec, const std::string &key);
  std::string get(const std::string &sec, const std::string &key, const std::string &def);
  ~ConfigParser(){};
private:
  int _argc;
  char **_argv;
  std::map<std::string, std::map<std::string,std::string>> _ndict;
  std::vector<std::string> split(std::string str, std::string delim);
};
