/**
 * Computes the spatial gradient of a
 * 2D wavefield
 * @author: Joseph Jennings
 * @version: 2017.01.26
 */
#ifndef IGRAD2_H_
#define IGRAD2_H_

#include <vector>
#include "my_operator.h"
#include "axis.h"

class igrad2 : public my_operator {
  public:
    igrad2(){};
    igrad2(std::vector<axis> uaxes);
    bool forward(bool add, my_vector *mod, my_vector *dat);
    bool adjoint(bool add, my_vector *mod, my_vector *dat);
    ~igrad2(){};

  private:
    int _nz, _nx, _nt;
    float _idz, _idx;
};

#endif /* IGRAD2_H_ */
