/**
 * 2D gradient operator that uses
 * 10th-order central difference
 * stencils
 * @author: Joseph Jennings
 * @version: 2017.04.25
 */

#ifndef IGRAD2CENT10TH_H_
#define IGRAD2CENT10TH_H_

#include <vector>
#include "my_operator.h"
#include "axis.h"

class igrad2cent10th : public my_operator {
  public:
    igrad2cent10th(){};
    igrad2cent10th(std::vector<axis> uaxes);
    bool forward(bool add, my_vector *mod, my_vector *dat);
    bool adjoint(bool add, my_vector *mod, my_vector *dat);
    ~igrad2cent10th(){};

  private:
    int _nz, _nx, _nt;
    float _idz, _idx;
    std::vector<double> _coefs = {0.833333333,-0.238095238,0.0595238095,-0.00992063492,0.000793650794};
};

#endif /* IGRAD2CENT10TH_H_ */
