/*
 * lininterp.h
 *
 *  Created on: Nov 4, 2016
 *      Author: joe
 */

#ifndef LININTERP_H_
#define LININTERP_H_

#include <tuple>
#include <vector>
#include "my_operator.h"
#include "hypercube_float.h"

class lininterp: public my_operator {
  public:
    lininterp(){} //Default constructor
    lininterp(int iaxis);
    lininterp(int iaxis, std::vector<float> coords);
    bool forward(bool add, my_vector *mod, my_vector *dat);
    bool adjoint(bool add, my_vector *mod, my_vector *dat);

    ~lininterp(){}

  private:
    std::tuple<int,float,float> wgts(hypercube_float *m, hypercube_float *d, int k);
    std::pair<float,float> wgts(float f);
    int _iax;
    std::vector<float> _coords;

};

#endif /* LININTERP_H_ */
