/**
 * The 1D K mask operator described
 * on page 181 of GIEE. Used in
 * non-stationary PEF inversions.
 * @author: Joseph Jennings
 * @version: 2017.12.21
 */

#ifndef LV_CONV1DMASK_H_
#define LV_CONV1DMASK_H_

#include <vector>
#include "axis.h"
#include "my_operator.h"

class lv_conv1dmask : public my_operator {
  public:
    lv_conv1dmask(){};
    bool forward(bool add, my_vector *mod, my_vector *dat);
    bool adjoint(bool add, my_vector *mod, my_vector *dat);
    ~lv_conv1dmask(){};
};

#endif /* LV_CONV1DMASK_H_ */
