/**
 * The K mask operator described
 * on page 181 of GIEE. Used in
 * non-stationary PEF inversions.
 * @author: Joseph Jennings
 * @version: 2017.03.20
 */

#ifndef LV_CONV2DMASK_H_
#define LV_CONV2DMASK_H_

#include <vector>
#include "axis.h"
#include "my_operator.h"

class lv_conv2dmask : public my_operator {
  public:
    lv_conv2dmask(){};
    bool forward(bool add, my_vector *mod, my_vector *dat);
    bool adjoint(bool add, my_vector *mod, my_vector *dat);
    ~lv_conv2dmask(){};
};

#endif /* LV_CONV2DMASK_H_ */
