/**
 * Multicomponent receiver
 * restriction operator
 * @author: Joseph Jennings
 * @version: 2017.01.28
 */
#ifndef MCRREC_H_
#define MCRREC_H_

#include "my_operator.h"
#include "hypercube_float.h"
#include "rrec.h"
#include "igrad2.h"
#include "integratewfld.h"

class mcrrec : public my_operator {
  public:
    mcrrec(){};
    mcrrec(std::vector<axis> uaxes, axis arx, int recz, float rho);
    virtual bool forward(bool add, my_vector *mod, my_vector *dat);
    virtual bool adjoint(bool add, my_vector *mod, my_vector *dat);
    ~mcrrec(){
      delete _mcwfld; delete _wfld; delete _wfldv; delete _sht;
      delete _iw;
    };

  private:
    int _nx, _nz, _nt, _nrx;
    hypercube_float *_mcwfld, *_wfld, *_wfldv, *_sht;
    rrec _rr;
    igrad2 _dzdx;
    integratewfld *_iw;
};

#endif /* MCRREC_H_ */
