/**
 * Multichannel transient convolution
 * Adjoint returns the input
 * @author: Joseph Jennings
 * @version: 2017.05.03
 */

#ifndef MCTCAI_H_
#define MCTCAI_H_

#include "my_operator.h"
#include "super_vector.h"

class mctcai : public my_operator {
  public:
    mctcai(){};
    mctcai(std::vector<my_operator*> ops);
    bool forward(bool adj, my_vector *mod, my_vector *dat);
    bool adjoint(bool adj, my_vector *mod, my_vector *dat);
    ~mctcai(){
      _ops.clear();
    };
  private:
    void create_super();
    std::vector<my_operator*> _ops;
};

#endif /* MCTCAI_H_ */
