/**
 * Polynomial division (deconvolution)
 * operator (non-helix)
 * @author: Joseph Jennings
 * @version: 2017.03.17
 */
#ifndef POLYDIV_H_
#define POLYDIV_H_

#include "my_operator.h"
#include "hypercube_float.h"

class polydiv : public my_operator {
  public:
    polydiv(){};
    polydiv(hypercube_float *flt);
    bool forward(bool add, my_vector *mod, my_vector *dat);
    bool adjoint(bool add, my_vector *mod, my_vector *dat);
    ~polydiv(){};
  private:
    hypercube_float *_flt;
    int _nf;
};

#endif /* POLYDIV_H_ */
