/**
 * Estimates a PEF on a scalar 1D time series
 * @author: Joseph Jennings
 * @version: 2017.06.13
 */

#ifndef SCTVPEF_H_
#define SCTVPEF_H_

#include <vector>
#include "hypercube_float.h"

class sctvpef {
  public:
    sctvpef(int na, int gap, float lambda);
    sctvpef(int na, int gap, float lambda, bool verb);
    sctvpef(std::vector<float> A, int gap, float lambda, bool verb);
    sctvpef(std::vector<float> A, int gap, float lambda);
    std::vector<float> findpef(hypercube_float *dat, hypercube_float *rsd);
    ~sctvpef(){};

  private:
    int _na, _gap;
    bool _verb;
    float _lambda, _eps;
    std::vector<float> _A;
};

#endif /* SCTVPEF_H_ */
