/**
 * Pads a shot gather in time.
 * Primarily used in blending shot gathers.
 * @author: Joseph Jennings
 * @version: 2017.01.22
 */
#ifndef SHOTPAD_H_
#define SHOTPAD_H_

#include "my_operator.h"
#include "axis.h"

class shotpad : public my_operator {
  public:
    shotpad(){};
    shotpad(axis taxis);
    shotpad(axis taxis, float time);
    void set_time(float time);
    bool forward(bool add, my_vector *mod, my_vector *dat);
    bool adjoint(bool add, my_vector *mod, my_vector *dat);
    ~shotpad(){};

  private:
    int _nt, _ntshift;
    float _ot, _dt;
};

#endif /* SHOTPAD_H_ */
