/*
 * tcai.cpp
 *
 *  Created on: Nov 22, 2016
 *      Author: joe
 */

#include "tcai.h"

tcai::tcai(hypercube_float* flt) {
  _flt = flt;
  _nf = _flt->get_axis(1).n;
}

bool tcai::forward(bool add, my_vector *mod, my_vector *dat) {
  if(!add && dat) dat->zero();
  hypercube_float *m = (hypercube_float*) mod;
  hypercube_float *d = (hypercube_float*) dat;

  _nd = d->get_axis(1).n;
  _nm = m->get_axis(1).n;

  if(_nf != _nd - _nm + 1)
    seperr("tcai: size of filter does not match input and output.\n");

  for(int kf = 0; kf < _nf; ++kf) {
    for(int km = 0; km < _nm; ++km) {
      int kd = km + kf;
      d->vals[kd] += scale * m->vals[km] * _flt->vals[kf];
    }
  }

  return true;
}

bool tcai::adjoint(bool add, my_vector *mod, my_vector *dat) {
  if(!add && mod) mod->zero();
  hypercube_float *m = (hypercube_float*) mod;
  hypercube_float *d = (hypercube_float*) dat;

  _nd = d->get_axis(1).n;
  _nm = m->get_axis(1).n;

  if(_nf != _nd - _nm + 1)
    seperr("tcai: size of filter does not match input and output.\n");

  for(int kf = 0; kf < _nf; ++kf) {
    for(int km = 0; km < _nm; ++km) {
      int kd = km + kf;
      m->vals[km] += scale * d->vals[kd] * _flt->vals[kf];
    }
  }

  return true;
}
