/**
 * Transient convolution operator
 * A port from Jon Claerbout's GEE library
 * @author: Joseph Jennings
 * @version: 2016.11.22
 */
#ifndef TCAI_H_
#define TCAI_H_

#include "my_operator.h"
#include "my_vector.h"
#include "hypercube_float.h"

class tcai : public my_operator {
  public:
    tcai(){}
    tcai(hypercube_float *flt);
    virtual bool forward(bool add, my_vector *mod, my_vector *dat);
    virtual bool adjoint(bool add, my_vector *mod, my_vector *dat);
    ~tcai(){}

  private:
    hypercube_float *_flt;
    int _nf, _nm, _nd;

};

#endif /* TCAI_H_ */
