#ifndef WAVELET_H
#define WAVELET_H 1

#include "axis.h"
#include "hypercube_float.h"
#include <math.h>

class wavelet{

public:
  wavelet(){}  //Default constructor does nothing
  wavelet(axis st);
  wavelet(axis st, float dly);
  void ricker(float f, hypercube_float *src);
  void bprandom(float f1, float f2, float f3, float f4, hypercube_float *src);
  void bprandom(std::vector<float> freqs, hypercube_float *src);
  void monosin(float f, float amp, float ph, hypercube_float *src);
  void sumsin(std::vector<float> fs, std::vector<float> amps, std::vector<float> phs, hypercube_float *src);
  void bandpass(float f1, float f2, float f3, float f4, hypercube_float *src);
  void bandpass(std::vector<float>freqs, hypercube_float *src);
  void gaussian(float a, float c, hypercube_float *src);
  void expdecay(float a, float b, hypercube_float *src);

  ~wavelet(){}

private:
  int _ntsrc;
  float _dtsrc, _ftsrc;
  float _dly = 0.0;
  float const DEG2RAD = M_PI/180.0;

};

#endif /* WAVELET_H_ */
