/**
 * Measures the deblending quality of the
 * deblended result
 * @author: Joseph Jennings
 * @version: 2018.03.30
 */

#include "sep_params.h"

int main(int argc, char **argv) {

  sep_params pars = sep_params(argc,argv);

  sregf debin = sregf("in");
  sregf unbin = sregf("unb");

  hypercube_float *deb  = new hypercube_float(debin.get_axes(),true);
  hypercube_float *unb  = new hypercube_float(unbin.get_axes(),true);
  hypercube_float *diff = new hypercube_float(debin.get_axes(),true);

  if(!deb->check_hypercube_match(unb)) seperr("Input axes must be the same.\n");

  debin.read_all("in",deb);
  unbin.read_all("unb",unb);

  float num = unb->dot(unb);
  diff->scale_add(1.0, deb, -1.0, unb);
  float denom = diff->dot(diff);

  float q = 10.0*log10(num/denom);
  fprintf(stderr,"%f dB\n",q);
  fprintf(stderr,"%f\n",num/denom);

}

